%define name	vim
%define ver	5.7
%define	rel	4
%define serial	2001032802
%define prefix	%{_prefix}

Summary: The VIM editor.
Name: %{name}
Version: %{ver}
Release: %{rel}
Copyright: special license (see README.txt)
Group: Applications/Editors
Source0: ftp://ftp.oce.nl/pub/vim/unix/vim-%{ver}-src.tar.gz
Source1: ftp://ftp.oce.nl/pub/vim/unix/vim-%{ver}-rt.tar.gz
Source2: vimx.wmconfig
Patch0: vim-4.2-speed_t.patch
Patch1: vim-5.1-vimnotvi.patch

## Official fix patch from ftp://ftp.vim.org/vim/patches/
Patch10: vim-5.7-patches-2001032801.patch
BuildRoot: /var/tmp/%{name}-%{version}-root
BuildRequires: perl python XFree86-devel gtk+-devel > 1.1.16
#NoSource: 0
#NoSource: 1

%description
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.

%package common
Summary: The common files needed by both versions of the VIM editor.
Group: Applications/Editors

%description common
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-common package
contains files which every VIM binary will need in order to run.

If you are installing any version of the VIM editor, you'll also need to
the vim-common package installed.

%package standard
BuildRequires: python-devel perl gtk+-devel /usr/bin/ctags
Summary: A version of the VIM editor which includes recent enhancements.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-color vim-enhanced vim-minimal

%description standard
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-standard package
contains a version of VIM with recently introduced features like Python and
Perl interpreters.

Install the vim-standard package if you'd like to use a version of the VIM
editor which includes recently added enhancements like interpreters for the
Python and Perl scripting languages.  You'll also need to install the
vim-common package.

Set a symlink to vim if you want it to be your default vi:
ln -sf /usr/bin/vim /bin/vi

%package X11
Summary: The VIM version of the vi editor for the X Window System.
Group: Applications/Editors
Requires: vim-common


%description X11
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more. VIM-X11 is a version of the
VIM editor which will run within the X Window System.  If you install this
package, you can run VIM as an X application with a full GUI interface and
mouse support.

Install the vim-X11 package if you'd like to try out a version of vi with
graphics and mouse capabilities.  You'll also need to install the
vim-common package.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/X11/wmconfig

%setup -q -b 1
%patch0 -p1 -b .4.2
%patch1 -p1 -b .vim

%patch10 -p0

# fix rogue dependencies from sample code
find . -name \*.paths | xargs rm -f

%build
cd src

CFLAGS="$RPM_OPT_FLAGS" ./configure \
		--prefix=%{prefix} \
		--enable-max-features=yes \
		--enable-pythoninterp \
		--enable-perlinterp \
		--disable-tclinterp \
		--with-x=yes \
		--enable-gui=gtk \
		--exec-prefix=%{prefix}
make 
mv vim gvim
make clean

CFLAGS="$RPM_OPT_FLAGS" ./configure \
		--prefix=%{prefix} \
		--enable-max-features=yes \
		--enable-pythoninterp \
		--enable-perlinterp \
		--disable-tclinterp \
		--with-x=no \
		--enable-gui=no \
		--exec-prefix=%{prefix}
make

cd ../runtime/doc
make html
mkdir ../html
mv *.html ../html

%install
rm -rf $RPM_BUILD_ROOT

cd src
make install \
	prefix=$RPM_BUILD_ROOT%{prefix} \
	exec_prefix=$RPM_BUILD_ROOT%{prefix} \
	MANDIR=$RPM_BUILD_ROOT%{prefix}/share/man 

make installmacros DATADIR=${RPM_BUILD_ROOT}%{prefix}/share

install -s -m755 gvim $RPM_BUILD_ROOT%{prefix}/bin
ln -s gvim $RPM_BUILD_ROOT%{prefix}/bin/vimx
cd ..

rm -f $RPM_BUILD_ROOT%{prefix}/bin/ex
gzip -9 README*.txt
mkdir -p $RPM_BUILD_ROOT/etc/X11/wmconfig
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/X11/wmconfig/gvim


# etags comes from emacs, ex from elvis
rm -f $RPM_BUILD_ROOT%{prefix}/share/man/man1/{rview,rvim,view,etags,ex}.1
# replace man page links with something that is gzip agnostic
echo .so man1/vim.1 > $RPM_BUILD_ROOT%{prefix}/share/man/man1/rview.1
echo .so man1/vim.1 > $RPM_BUILD_ROOT%{prefix}/share/man/man1/rvim.1
echo .so man1/vim.1 > $RPM_BUILD_ROOT%{prefix}/share/man/man1/view.1

# correct the vim installer which tries to be a little bit too smart here
( cd $RPM_BUILD_ROOT%{prefix}/share/man/man1
    perl -pi -e "s,$RPM_BUILD_ROOT,," vim.1 vimtutor.1
)
gzip -9 $RPM_BUILD_ROOT%{prefix}/share/man/man1/*
chmod -x $RPM_BUILD_ROOT%{prefix}/share/vim/*/tools/mve.awk

mkdir -p $RPM_BUILD_ROOT/bin
cp -a $RPM_BUILD_ROOT%{prefix}/bin/vim $RPM_BUILD_ROOT/bin/vi

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(-,root,root)
%doc README*.txt.gz
%doc runtime/html runtime/termcap runtime/tutor
%doc runtime/*.vim
%{prefix}/bin/vimtutor
%{prefix}/bin/xxd

%{prefix}/share/vim
%{prefix}/share/man/man1/rview.1*
%{prefix}/share/man/man1/rvim.1*
%{prefix}/share/man/man1/view.1*
%{prefix}/share/man/man1/vim.1*
%{prefix}/share/man/man1/vimtutor.1*
%{prefix}/share/man/man1/xxd.1*

%files standard
%defattr(-,root,root)
%{prefix}/bin/vim
%{prefix}/bin/view
%{prefix}/bin/rvim
%{prefix}/bin/rview
/bin/vi

%files X11
%defattr(-,root,root)
%config(missingok) /etc/X11/wmconfig/gvim
%{prefix}/bin/gvim
%{prefix}/bin/vimx

%changelog
* Wed Mar 28 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added official patches. (001-025).

* Mon Feb 19 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Modified file section of man pages.

* Tue Aug 15 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Modofied SPEC file.
- Modified to install /bin/vim

* Thu Jul 13 2000 Roger Luethi <rluethi@turbolinux.com>
- update to 5.7
- build and include HTML documentation

* Sun Mar 26 2000 Roger Luethi <rluethi@turbolinux.com>
- stop linking /usr/bin/vim with X libs
- moved gvim and vimx from /usr/X11R6/bin to /usr/bin
- use smarter solution for man page links

* Wed Mar 8 2000 Roger Luethi <rluethi@turbolinux.com>
- update to 5.6
- removed doc from %doc (it is included under /usr/share/vim)
- removed vim-5.4-CorrectPerlPath.patch (obsolete)

* Mon Dec 13 1999 Robert Read <rread@turbolinux.com>
- Fixed the help files.

* Fri Oct 29 1999 Roger Luethi <rluethi@turbolinux.com>
- added BuildRequires: perl python XFree86-devel gtk+-devel > 1.1.16
- renamed vim-5.4-paths.patch to vim-5.4-CorrectPerlPath.patch
- moved man pages from /usr/man to /usr/share/man
- rewrote major portions of spec file, removed vim-minimal sub package in order
  to get along with our new default vi (elvis)
- removed duplicates in the documentation.
- removed source file vimrc; a .vimrc is in etcskeleton.
- fixed documentation to reflect the changes

* Tue Oct 12 1999 Kelley Spoon <kspoon@turbolinux.com>
- vi is no longer our default vi... Hail to the King, baby.
  elvis has entered the building.

* Fri Aug 6 1999 Anh Vo <anhvo@turbolinux.com>
- Built for TL

* Tue Jul 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved from athena to gtk widgets for X version
- removed vim.1 from X11 filelist because X11 depends on vim-common anyway
- fixed rogue dependencies from sample files

* Tue Jul 27 1999 Jeff Johnson <jbj@redhat.com>
- update to 5.4.

* Thu Jul 22 1999 Jeff Johnson <jbj@redhat.com>
- man page had buildroot pollution (#3629).

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- with recent termcap/terminfo fixes, regular vim works in xterm/console
- in color, so vim-color package removed.

* Tue Mar 23 1999 Erik Troan <ewt@redhat.com>
- removed "set backupdir=/tmp/vim_backup" from default vimrc

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 5)

* Thu Dec 17 1998 Michael Maher <mike@redaht.com>
- built pacakge for 6.0

* Tue Sep 15 1998 Michael Maher <mike@redhat.com>
- removed '--with-tlib=termcap' so that color-vim works

* Wed Sep  2 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.3.

* Mon Aug 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in Toshio's changes
- color-vim: changed "--disable-p" to "--disable-perlinterp --with-tlib=termcap"
- added minimal rvi/rview and man pages.
- move Obsoletes to same package as executable.

* Thu Aug 06 1998 Toshio Kuratomi <badger@prtr-13.ucsc.edu>
- Break the package apart similar to the way the netscape package was
  broken down to handle navigator or communicator: The vim package is
  Obsolete, now there is vim-common with all the common files, and a
  package for each binary: vim-minimal (has /bin/vi compiled with no
  frills), vim-enhanced (has /usr/bin/vim with extra perl and python
  interpreters), and vim-X11 (has /usr/X11R6/bin/gvim compiled with
  GUI support.)
- Enable the perl and python interpreters in the gui version (gvim).

* Tue Jun 30 1998 Michael Maher <mike@redhat.com>
- Fixed tutor help.
- cvim package added.  Thanks to Stevie Wills for finding this one :-)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri May 01 1998 Donnie Barnes <djb@redhat.com>
- added patch to turn off the "vi compatibility" by default.  You can
  still get it via the -C command line option

* Thu Apr 23 1998 Donnie Barnes <djb@redhat.com>
- removed perl and python interpreters (sorry, but those don't belong
  in a /bin/vi and having two vi's seemed like overkill...complain
  to suggest@redhat.com if you care)

* Fri Apr 17 1998 Donnie Barnes <djb@redhat.com>
- fixed buildroot bug

* Sat Apr 11 1998 Donnie Barnes <djb@redhat.com>
- updated from 4.6 to 5.1
- moved to buildroot

* Sun Nov 09 1997 Donnie Barnes <djb@redhat.com>
- fixed missing man page

* Wed Oct 22 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry to vim-X11

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- upgraded from 4.5 to 4.6

* Fri Jun 13 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Michael K. Johnson <johnsonm@redhat.com>
- Upgraded to 4.5
- Added ex symlinks

* Tue Mar 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added view symlink.
